unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    e_fn: TEdit;
    Label1: TLabel;
    Button1: TButton;
    od: TOpenDialog;
    sd: TSaveDialog;
    Button2: TButton;
    rb128: TRadioButton;
    rb256: TRadioButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure rb128Click(Sender: TObject);
    procedure rb256Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

type TMidi = record
  t: integer;
  d: byte;
end;

var
  Form1: TForm1;
  f_in, fout: file of byte;
  bytes, mmcpos: integer;
  fsize: integer = 256;

implementation

{$R *.DFM}

procedure writestr(s: string);
var dat: byte;
    i: integer;
begin
  for i:=1 to length(s) do
  begin
   dat := ord(s[i]);
   write(fout, dat);
   inc(bytes);
  end;
end;

function getdata: TMidi;
var dat: byte;
    i: TMidi;
begin
  read(f_in, dat);
  i.t := ((dat shl 16) AND $00FF0000);
  read(f_in, dat);
  i.t := i.t + ((dat shl 8) AND $0000FF00);
  read(f_in, dat);
  i.t := i.t + (dat AND $000000FF);
  read(f_in, dat);
  i.d := dat;
  result := i;
  inc(mmcpos, 4);
end;

procedure writedata(d: TMidi);
var c: byte;
begin
  c := (d.t AND $00FF0000) shr 16;
  write(fout, c);
  c := (d.t AND $0000FF00) shr 8;
  write(fout, c);
  c := (d.t AND $000000FF);
  write(fout, c);
  c := d.d;
  write(fout, c);
  inc(mmcpos, 4);
end;

function vl(v: integer): string;
var b: integer;
    s: string;
begin
  s := '';
  b := v AND $7F;
  while ((v shr 7) > 0) do
  begin
   v := v shr 7;
   b := b shl 8;
   b := b OR $80;
   b := b + (v AND $7F);
  end;
  while (true) do
  begin
   s := s + chr(b);
   if (b AND $80) > 0 then
    b := b shr 8
   else
    break;
  end;
  result := s;
end;

function vl_: longint;
var v: longint;
    c: byte;
begin
  read(f_in, c);
  v := c;
  if (v AND $80) > 0 then
  begin
   v := v AND $7F;
   repeat
    read(f_in, c);
    v := (v shl 7) + (c AND $7F);
   until (c AND $80) = 0;
  end;
  result := v;
end;

procedure TForm1.Button1Click(Sender: TObject);
var i, c, fnr, zeit, azeit: integer;
    adp0: byte;
    ts: string;
    dp: Array [0..20] of TMidi;
begin
  sd.Title := 'Select a FORMAT 0 Midi file';
  od.Title := 'Select the SD/MMC card file to convert';
  sd.DefaultExt := 'mid';
  od.DefaultExt := 'txt';
  sd.Filter := 'MIDI files (*.mid)|*.mid|All files (*.*)|*.*';
  od.Filter := 'Text files (*.txt)|*.txt|All files (*.*)|*.*';
  if od.Execute and sd.Execute then
  begin
   assignfile(f_in, od.FileName);
   reset(f_in);
   assignfile(fout, sd.FileName);
   rewrite(fout);

   fnr := strtoint(e_fn.Text);
   seek(f_in, 512 * fsize * fnr);
   mmcpos := 0;

   writestr('MThd'#0#0#0#6#0#0#0#1#7#161'MTrk'#0#0#0#0);
   bytes := 0;
   azeit := 0;
   adp0 := 0;
   dp[0].d := $FC;
   dp[0].t := 0;

   repeat
    dp[0] := getdata;

    if dp[0].d < $80 then
    begin
     dp[1] := dp[0];
     dp[0].d := adp0;
     i := 1;
    end else i := 0;

    zeit := dp[0].t;
    if zeit = $FFFFFF then break;

    ts := vl(zeit - azeit);

    if dp[0].d = $F0 then  // Sysex
    begin
     repeat
      inc(i);
      dp[i] := getdata;
     until (dp[i].d = $F7) or (i = 20);
    end

    else if dp[0].d = $F2 then
    while i<2 do
    begin
     inc(i);
     dp[i] := getdata;
    end

    else if dp[0].d = $F3 then
    while i<1 do
    begin
     inc(i);
     dp[i] := getdata;
    end

    else if (dp[0].d AND $F0) in [$C0, $D0] then
    while i<1 do
    begin
     inc(i);
     dp[i] := getdata;
    end

    else if (dp[0].d AND $F0) in [$80, $90, $A0, $B0, $E0] then
    while i<2 do
    begin
     inc(i);
     dp[i] := getdata;
    end;

    c := 0;
    repeat
     ts := ts + chr(dp[c].d);
     inc(c);
    until c-1 >= i;
    if (dp[0].d >= $80) and (dp[0].d <> $FC) then
     writestr(ts);

    azeit := zeit;
    adp0 := dp[0].d;
   until dp[0].d = $FC;

   writestr(#0#255#47#0);

   seek(fout, $12);
   writestr(chr((bytes AND $FF000000) shr 24) + chr((bytes AND $00FF0000) shr 16) + chr((bytes AND $0000FF00) shr 8) + chr((bytes AND $000000FF)));

   closefile(f_in);
   closefile(fout);
   application.MessageBox(pchar('This file occupies '+inttostr(mmcpos div (512*fsize) + 1)+' file number spaces.'),'Conversion complete!',mb_iconinformation);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var d1, d2, d3, d4, adp0: byte;
    d: Array [0..100] of byte;
    i, c, gr, anz, dt: integer;
    faktor, tpqn, uspqn, zeit: double;
    dp: Array [0..20] of TMidi;
    s: string;
begin
  od.Title := 'Select a FORMAT 0 Midi file to convert';
  sd.Title := 'Select the destination card file';
  od.DefaultExt := 'mid';
  sd.DefaultExt := 'txt';
  od.Filter := 'MIDI files (*.mid)|*.mid|All files (*.*)|*.*';
  sd.Filter := 'Text files (*.txt)|*.txt|All files (*.*)|*.*';
  s := '1';
  if not inputquery('Factor PC->Mr.MIDI','Enter time factor (big=slow):',s) then exit;
  val(s, faktor, c);
  if od.Execute and sd.Execute then
  begin
   assignfile(f_in, od.FileName);
   reset(f_in);

   read(f_in, d1);
   read(f_in, d2);
   read(f_in, d3);
   read(f_in, d4);
   if (d1<>ord('M')) or (d2<>ord('T')) or (d3<>ord('h')) or (d4<>ord('d')) then
   begin
    application.MessageBox('This is no MIDI file!','Error',mb_iconerror);
    closefile(f_in);
    exit;
   end;

   seek(f_in, 8);
   read(f_in, d1);
   read(f_in, d2);
   read(f_in, d3);
   read(f_in, d4);
   if (d1=0) and (d2=0) and (d3=0) and (d4=1) then
   begin     // Konvertierung mglich
    read(f_in, d1);
    read(f_in, d2);
    tpqn := d1*256 + d2;
    uspqn := 500000;

    read(f_in, d1);
    read(f_in, d2);
    read(f_in, d3);
    read(f_in, d4);
    if (d1<>ord('M')) or (d2<>ord('T')) or (d3<>ord('r')) or (d4<>ord('k')) then
    begin
     application.MessageBox('This is no MIDI file!','Error',mb_iconerror);
     closefile(f_in);
     exit;
    end;
    read(f_in, d1);
    read(f_in, d2);
    read(f_in, d3);
    read(f_in, d4);
    gr := d1*16777216 + d2*65536 + d3*256 + d4;

    assignfile(fout, sd.FileName);
    reset(fout);
    seek(fout, 512*fsize*strtoint(e_fn.text));
    mmcpos := 0;
    anz := 0;
    zeit := 0;
    adp0 := $FC;

    repeat
     dt := vl_;
     zeit := zeit + faktor * (dt * uspqn / tpqn) / 128;

     i := 0;
     read(f_in, d[0]);
     inc(anz);
     dp[0].d := d[0];
     dp[0].t := trunc(zeit) AND $00FFFFFF;

     if dp[0].d < $80 then  // "Running Status"
     begin
      d[1] := d[0];
      d[0] := adp0;
      dp[0].d := d[0];
      dp[1].d := d[1];
      dp[1].t := trunc(zeit) AND $00FFFFFF;
      i := 1;
     end else
      adp0 := d[0];

     if dp[0].d = $FF then  // Meta-Event
     begin
      inc(i);
      read(f_in, d[i]);
      inc(anz);
      c := 1;
      if (d[i] = 0) or (d[i] = $2F) then c := 1
      else if ((d[i]>=1) and (d[i]<=7)) or (d[i]=$7F) then
       c := vl_ + 1
      else if (d[i] = $20) then c := 2
      else if (d[i] = $59) then c := 4
      else if (d[i] = $51) then c := 5
      else if (d[i] = $58) then c := 6
      else if (d[i] = $54) then c := 7;

      repeat
       inc(i);
       read(f_in, d[i]);
       inc(anz);
      until i >= c;

      if d[1]=$51 then
       uspqn := d[2]*65536 + d[3]*256 + d[4];
     end

     else if dp[0].d = $F0 then  // Sysex
     begin
      repeat
       inc(i);
       read(f_in, d[i]);
       inc(anz);
       dp[i].d := d[i];
       dp[i].t := trunc(zeit) AND $00FFFFFF;
      until (dp[i].d = $F7) or (i = 20);
     end

     else if dp[0].d = $F2 then
     while i<2 do
     begin
      inc(i);
      read(f_in, d[i]);
      inc(anz);
      dp[i].d := d[i];
      dp[i].t := trunc(zeit) AND $00FFFFFF;
     end

     else if dp[0].d = $F3 then
     while i<1 do
     begin
      inc(i);
      read(f_in, d[i]);
      inc(anz);
      dp[i].d := d[i];
      dp[i].t := trunc(zeit) AND $00FFFFFF;
     end

     else if (dp[0].d AND $F0) in [$C0, $D0] then
     while i<1 do
     begin
      inc(i);
      read(f_in, d[i]);
      inc(anz);
      dp[i].d := d[i];
      dp[i].t := trunc(zeit) AND $00FFFFFF;
     end

     else if (dp[0].d AND $F0) in [$80, $90, $A0, $B0, $E0] then
     while i<2 do
     begin
      inc(i);
      read(f_in, d[i]);
      inc(anz);
      dp[i].d := d[i];
      dp[i].t := trunc(zeit) AND $00FFFFFF;
     end;

     if (dp[0].d<>$FF) and (dp[0].d>=$80) then
      for c := 0 to i do
      begin
       writedata(dp[c]);
      end;

    until ((d[0]=$FF) and (d[1]=$2F) and (d[2]=0)) or (anz >= gr);

    dp[0].d := $FC;
    dp[0].t := trunc(zeit) AND $00FFFFFF;
    writedata(dp[0]);
    closefile(fout);
    application.MessageBox(pchar('This file occupies '+inttostr(mmcpos div (512*fsize) + 1)+' file number spaces.'),'Conversion complete!',mb_iconinformation);
   end else
     application.MessageBox('This is no supported MIDI format!','Error',mb_iconerror);

   closefile(f_in);
  end;
end;

procedure TForm1.rb128Click(Sender: TObject);
begin
  fsize := 128;
end;

procedure TForm1.rb256Click(Sender: TObject);
begin
  fsize := 256;
end;

end.
